<?php

class ACMS_POST_Entry_Update extends ACMS_POST_Entry
{
    /**
     * @var array
     */
    var $fieldNames  = array ();

    /**
     * @see ACMS_User_POST_EntryExtendSample_Update
     *
     * @param string            $fieldName
     * @param int               $eid
     * @param Field_Validation  $Field
     * @return void
     */
    function saveCustomField($fieldName, $eid, $Field)
    {

    }

    function copyFieldArchives($from, $to, $preApproval=false)
    {
        //----------------------------------
        // カスタムフィールドファイルを一時コピー
        $_RVID = RVID;
        if ( $preApproval ) {
            $_RVID = 1;
        }
        $revisionField  = loadEntryField(EID, $_RVID);
        foreach ( $revisionField->listFields() as $fd ) {
            if ( 1
                and !strpos($fd, '@path')
                and !strpos($fd, '@tinyPath')
                and !strpos($fd, '@largePath')
                and !strpos($fd, '@squarePath')
            ) {
                continue;
            }
            foreach ( $revisionField->getArray($fd, true) as $i => $val ) {
                $path   = $val;
                if ( !is_file($from.$path) ) continue;
                $info       = pathinfo($path);
                $dirname    = empty($info['dirname']) ? '' : $info['dirname'].'/';
                $this->setupDir($to.$dirname, intval(config('permission_dir')));
                
                @copy($from.$path, $to.$path);
            }
        }
    }

    function copyUnitArchives($from, $to, $preApproval=false)
    {
        //------
        // Unit
        $DB = DB::singleton(dsn());

        $_RVID = RVID;
        if ( $preApproval ) {
            $_RVID = 1;
        }
        if ( $_RVID ) {
            $SQL    = SQL::newSelect('column_rev');
            $SQL->addWhereOpr('column_rev_id', $_RVID);
        } else {
            $SQL    = SQL::newSelect('column');
        }
        $SQL->addWhereOpr('column_entry_id', EID);
        $SQL->addWhereOpr('column_blog_id', BID);
        $q = $SQL->get(dsn());

        if ( $DB->query($q, 'fetch') and ($row = $DB->fetch($q)) ) { do {
            switch ( $row['column_type'] ) {
                case 'image':
                    if ( empty($row['column_field_2']) ) break;
                    $oldAry = explodeUnitData($row['column_field_2']);
                    foreach ( $oldAry as $old ) {
                        $info   = pathinfo($old);
                        $dirname= empty($info['dirname']) ? '' : $info['dirname'].'/';
                        $this->setupDir($to.$dirname, intval(config('permission_dir')));

                        $path   = $from.$old;
                        $large  = otherSizeImagePath($path, 'large');
                        $tiny   = otherSizeImagePath($path, 'tiny');
                        $square = otherSizeImagePath($path, 'square');

                        $newPath    = $to.$old;
                        $newLarge   = otherSizeImagePath($newPath, 'large');
                        $newTiny    = otherSizeImagePath($newPath, 'tiny');
                        $newSquare  = otherSizeImagePath($newPath, 'square');

                        copyFile($path, $newPath);
                        copyFile($large, $newLarge);
                        copyFile($tiny, $newTiny);
                        copyFile($square, $newSquare);
                    }
                    break;
                case 'file':
                    if ( empty($row['column_field_2']) ) break;
                    $oldAry = explodeUnitData($row['column_field_2']);
                    foreach ( $oldAry as $old ) {
                        $info   = pathinfo($old);
                        $dirname= empty($info['dirname']) ? '' : $info['dirname'].'/';
                        $this->setupDir($to.$dirname, intval(config('permission_dir')));

                        $path   = $from.$old;
                        $newPath    = $to.$old;
                        
                        copyFile($path, $newPath);
                    }
                    break;
                case 'custom':
                    if ( empty($row['column_field_6']) ) break;
                    $oldAry = explodeUnitData($row['column_field_6']);
                    foreach ( $oldAry as $fieldString ) {
                        $Field = acmsUnserialize($fieldString);
                        foreach ( $Field->listFields() as $fd ) {
                            if ( 1
                                and !strpos($fd, '@path')
                                and !strpos($fd, '@tinyPath')
                                and !strpos($fd, '@largePath')
                                and !strpos($fd, '@squarePath')
                            ) {
                                continue;
                            }
                            foreach ( $Field->getArray($fd, true) as $i => $old ) {
                                $info       = pathinfo($old);
                                $dirname    = empty($info['dirname']) ? '' : $info['dirname'].'/';
                                $this->setupDir($to.$dirname, intval(config('permission_dir')));

                                $path = $from.$old;
                                $newPath = $to.$old;

                                copyFile($path, $newPath);
                            }
                        }
                    }
                    break;
            }
        } while ( $row = $DB->fetch($q) ); }
    }

    function update($exceptField=false)
    {
        $DB     = DB::singleton(dsn());
        $Entry  =& $this->extract('entry');
        $this->fix($Entry);
        $CustomFieldCollection = array();

        //-------------------------------------
        // 公開済み or 承認前 エントリー
        // $preApproval     => 承認前エントリー
        // $updateApproval  => 承認済エントリー 
        $preEntry       = ACMS_RAM::entry(EID);
        $approvalStatus = $preEntry['entry_approval'];
        $preApproval    = enableApproval() && $approvalStatus === 'pre_approval';
        $updateApproval = enableApproval() && $approvalStatus !== 'pre_approval';

        if ( sessionWithApprovalAdministrator() ) {
            $preApproval    = false;
            $updateApproval = false;
        }

        //----------------------------
        // 未来バージョンとして保存フラグ
        $revisionDraft = false;
        if ( 1
            && enableRevision(false)
            && $Entry->get('revision_type') == 'draft_revision'
        ) {
            $revisionDraft = true;
        }

        //------
        // cid
        if ( !($cid = $Entry->get('category_id')) ) $cid = null;
        $Entry->setMethod('status', 'required');
        $Entry->setMethod('status', 'in', array('open', 'close', 'draft', 'trash'));
        $Entry->setMethod('status', 'category', true);
//        $Entry->setMethod('status', 'category', is_null($cid) ? true : !(1
//            and 'close' == ACMS_RAM::categoryStatus($cid)
//            and 'open'  == $Entry->get('status')
//        ));
        $Entry->setMethod('title', 'required');
        if ( !!($code = strval($Entry->get('code'))) ) {
            if ( !config('entry_code_extension') ) {
                $Entry->setMethod('code', 'reserved', !isReserved($code));
            }
            if ( config('check_duplicate_entry_code') === 'on'  ) {
                $Entry->setMethod('code', 'double', !$this->validEntryCodeDouble($code, BID, $cid, EID));
            }
        }

        $Entry->setMethod('indexing', 'required');
        $Entry->setMethod('indexing', 'in', array('on', 'off'));
        $Entry->setMethod('entry', 'operable', $this->isOperable());

        $Entry->validate(new ACMS_Validator());

        //------------------------------------
        // カスタムフィールドファイルを一時的にコピー
        $moveFieldArchive = false;
        // リビジョンから変更
        if ( RVID && !$updateApproval ) {
            $this->copyFieldArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
            $moveFieldArchive = ($revisionDraft) ? 'REVISON_ARCHIVES_DIR' : 'ARCHIVES_DIR';
        // 公開エントリから下書き
        } else if ( $revisionDraft ) {
            $this->copyFieldArchives(ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
            $moveFieldArchive = 'REVISON_ARCHIVES_DIR';
        // 承認機能 ON まだエントリが存在しない場合
        } else if ( $preApproval ) {
            $this->copyFieldArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR, true);
        // 承認機能 ON エントリ存在
        } else if ( !RVID && $updateApproval ) {
            $this->copyFieldArchives(ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
            $moveFieldArchive = 'REVISON_ARCHIVES_DIR';
        // 承認機能 ON リビジョンから変更
        } else if ( RVID && $updateApproval ) {
            $this->copyFieldArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
            $moveFieldArchive = 'REVISON_ARCHIVES_DIR';
        }

        //--------------
        // custom field
        $deleteField = new Field();
        $Field  =& $this->extract('field', new ACMS_Validator(), $deleteField, $moveFieldArchive);
        foreach ( $this->fieldNames as $fieldName ) {
            $CustomFieldCollection[$fieldName]   =& $this->extract($fieldName, new ACMS_Validator());
        }

        //-------
        // entry
        $range  = strval($Entry->get('summary_range'));
        $range  = ('' === $range) ? null : intval($range);

        $moveArchives = false;
        if ( !$this->Post->isValidAll() ) {
            $Column = $this->extractColumn($range, false); // old画像を削除しない
            $this->Post->set('step', 'reapply');
            $this->Post->set('action', 'update');
            $this->Post->set('column', acmsSerialize($Column));
            return false;
        } else {
            //----------------------------- 
            // ユニットファイルを一時的にコピー
            // リビジョンから変更
            if ( RVID && !$updateApproval ) {
                $this->copyUnitArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
                $moveArchives = ($revisionDraft) ? 'REVISON_ARCHIVES_DIR' : 'ARCHIVES_DIR';
            // 公開エントリから下書き
            } else if ( $revisionDraft ) {
                $this->copyUnitArchives(ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
                $moveArchives = 'REVISON_ARCHIVES_DIR';
            // 承認機能 ON まだエントリが存在しない場合
            } else if ( $preApproval ) {
                $this->copyUnitArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR, true);
            // 承認機能 ON エントリ存在
            } else if ( !RVID && $updateApproval ) {
                $this->copyUnitArchives(ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
                $moveArchives = 'REVISON_ARCHIVES_DIR';
            // 承認機能 ON リビジョンから変更
            } else if ( RVID && $updateApproval ) {
                $this->copyUnitArchives(REVISON_ARCHIVES_DIR, ARCHIVES_DIR.'TEMP/');
                $moveArchives = 'REVISON_ARCHIVES_DIR';
            }

            //-----------------------------
            // ユニットの整形＆ファイル類の生成
            $Column = $this->extractColumn($range, true, false, $moveArchives);
        }

        //--------
        // column
        $primaryImageId = 0;
        // 下書きバージョンでない場合
        if ( !$revisionDraft && !$updateApproval ) {
            $Res    = $this->saveColumn($Column, EID, BID, false, RVID, $moveArchives);
            $primaryImageId = empty($Res) ? null : (
                !$Entry->get('primary_image') ? reset($Res) : (
                    !empty($Res[$Entry->get('primary_image')]) ? $Res[$Entry->get('primary_image')] : reset($Res)
                )
            );
        }

        //-------------
        // title, code
        $title  = $Entry->get('title');
        $code   = trim(strval($Entry->get('code')), '/');
        if ( !empty($code) and !!config('entry_code_extension') and !strpos($code, '.') ) $code .= ('.'.config('entry_code_extension'));

        //--------------------------------------
        // status, start_datetime, end_datetime
        $status = $Entry->get('status');
        $datetime   = ( 'open' == $status and 'draft' == ACMS_RAM::entryStatus(EID) and config('update_datetime_as_entry_open') !== 'off' ) ?
            date('Y-m-d H:i:s', REQUEST_TIME) : $Entry->get('date').' '.$Entry->get('time')
        ;

        $SQL    = SQL::newUpdate('entry');
        $row    = array(
            'entry_category_id'     => $cid,
            'entry_code'            => $code,
            'entry_summary_range'   => $range,
            'entry_status'          => $status,
            'entry_title'           => $title,
            'entry_link'            => strval($Entry->get('link')),
            'entry_datetime'        => $datetime,
            'entry_start_datetime'  => $Entry->get('start_date').' '.$Entry->get('start_time'),
            'entry_end_datetime'    => $Entry->get('end_date').' '.$Entry->get('end_time'),
            'entry_indexing'        => $Entry->get('indexing', 'on'),
            'entry_primary_image'   => $primaryImageId,
            'entry_updated_datetime'=> date('Y-m-d H:i:s', REQUEST_TIME),
        );

        if ( !$preApproval ) {
            $row['entry_approval']  = 'none';
        }

        //-------------------------
        // 下書きバージョンでない場合
        if ( !$revisionDraft && !$updateApproval ) {
            foreach ( $row as $key => $val ) $SQL->addUpdate($key, $val);
            $SQL->addWhereOpr('entry_id', EID);
            $SQL->addWhereOpr('entry_blog_id', BID);
            $DB->query($SQL->get(dsn()), 'exec');

            $SQL    = SQL::newSelect('entry');
            $SQL->addWhereOpr('entry_id', EID);
            $SQL->addWhereOpr('entry_blog_id', BID);
            ACMS_RAM::entry(EID, $DB->query($SQL->get(dsn()),'row'));

            //-----
            // tag
            $SQL    = SQL::newDelete('tag');
            $SQL->addWhereOpr('tag_entry_id', EID);
            $DB->query($SQL->get(dsn()), 'exec');
            $tags   = $Entry->get('tag');
            if ( !empty($tags) ) {
                $tags   = preg_split(REGEXP_SEPARATER, $tags, -1, PREG_SPLIT_NO_EMPTY);
                $tags   = array_unique($tags);
                foreach ( $tags as $sort => $tag ) {
                    if ( isReserved($tag) ) continue;
                    $SQL    = SQL::newInsert('tag');
                    $SQL->addInsert('tag_name', $tag);
                    $SQL->addInsert('tag_sort', $sort + 1);
                    $SQL->addInsert('tag_entry_id', EID);
                    $SQL->addInsert('tag_blog_id', BID);
                    $DB->query($SQL->get(dsn()), 'exec');
                }
            }

            //---------------
            // related entry
            $this->saveRelatedEntries(EID, $Entry->getArray('related'));

            if ( !$exceptField ) {
                //-------
                // field
                $this->saveField('eid', EID, $Field, null, RVID, $moveFieldArchive);

                //--------------
                // custom field
                foreach ( $CustomFieldCollection as $fieldName => $customField ) {
                    $this->saveCustomField($fieldName, EID, $customField);
                }
            }

            //----------
            // fulltext
            $this->saveFulltext('eid', EID, $this->loadEntryFulltext(EID));

            //-----------
            // trackback
            if ( $endpoint = $Entry->get('trackback_url') ) {
                $this->pingTrackback($endpoint, EID);
            }
        }

        //-----------------
        // create revision
        if ( enableRevision(false) ) {
            $rvid   = $this->saveEntryRevision(EID, $row, $Entry->get('revision_type'), $Entry->get('revision_memo'));
            if ( $revisionDraft || $updateApproval ) {
                $Res    = $this->saveUnitRevision($Column, EID, BID, $rvid, $moveArchives);
            } else {
                $Res    = $this->saveUnitRevision($Column, EID, BID, $rvid);
            }
            $primaryImageId = empty($Res) ? null : (
                !$Entry->get('primary_image') ? reset($Res) : (
                    !empty($Res[$Entry->get('primary_image')]) ? $Res[$Entry->get('primary_image')] : reset($Res)
                )
            );

            if ( $revisionDraft || $updateApproval ) {
                // primaryImageIdを更新
                $SQL = SQL::newUpdate('entry_rev');
                $SQL->addUpdate('entry_primary_image', $primaryImageId);
                $SQL->addWhereOpr('entry_id', EID);
                $SQL->addWhereOpr('entry_rev_id', $rvid);
                $SQL->addWhereOpr('entry_blog_id', BID);
                $DB->query($SQL->get(dsn()), 'exec');

                $this->saveFieldRevision(EID, $Field, $rvid, $moveFieldArchive);
            } else {
                $this->saveFieldRevision(EID, $Field, $rvid);
            }

            $tags       = $Entry->get('tag');
            $SQL    = SQL::newDelete('tag_rev');
            $SQL->addWhereOpr('tag_entry_id', EID);
            $SQL->addWhereOpr('tag_rev_id', $rvid);
            $DB->query($SQL->get(dsn()), 'exec');
            if ( !empty($tags) ) {
                $tags   = preg_split(REGEXP_SEPARATER, $tags, -1, PREG_SPLIT_NO_EMPTY);
                $tags   = array_unique($tags);
                foreach ( $tags as $sort => $tag ) {
                    if ( isReserved($tag) ) continue;
                    $SQL    = SQL::newInsert('tag_rev');
                    $SQL->addInsert('tag_name', $tag);
                    $SQL->addInsert('tag_sort', $sort + 1);
                    $SQL->addInsert('tag_entry_id', EID);
                    $SQL->addInsert('tag_blog_id', BID);
                    $SQL->addInsert('tag_rev_id', $rvid);
                    $DB->query($SQL->get(dsn()), 'exec');
                }
            }

            //---------------
            // related entry
            $this->saveRelatedEntries(EID, $Entry->getArray('related'), $rvid);

            // エントリのカレントリビジョンを変更
            if ( !$revisionDraft && ( !enableApproval() || sessionWithApprovalAdministrator() ) ) {
                $SQL    = SQL::newUpdate('entry');
                $SQL->addUpdate('entry_current_rev_id', $rvid);
                $SQL->addWhereOpr('entry_id', EID);
                $SQL->addWhereOpr('entry_blog_id', BID);
                $DB->query($SQL->get(dsn()), 'exec');
            }
            deleteDirectory(ARCHIVES_DIR.'TEMP/');

            if ( $preApproval ) {
                $this->entryArchivesDelete(EID);
            }
        }

        if ( $revisionDraft || $updateApproval ) {
            $cid = ACMS_RAM::entryCategory(EID);
        }

        //-------------------
        // キャッシュクリア予約
        $this->updateCacheControl($row['entry_start_datetime'], $row['entry_end_datetime'], BID, EID);

        $SQL = SQL::newSelect('entry');
        $SQL->addSelect('entry_status');
        $SQL->addWhereOpr('entry_id', EID);
        $SQL->addWhereOpr('entry_blog_id', BID);
        $status = $DB->query($SQL->get(dsn()), 'one');

        return array('eid' => EID, 'cid' => $cid, 'ecd' => $code, 'ccd' => ACMS_RAM::categoryCode($cid), 'trash' => $status);
    }

    function post()
    {
        $updatedResponse = $this->update();

        // nextstep周りの実装は、プレビューが会った頃の古いコード
        // resultのみ機能しているが、confirmをしてもプレビューにならない（即時保存されている）

        $redirect   = $this->Post->get('redirect');
        $nextstep   = $this->Post->get('nextstep');
        $backend    = $this->Post->get('backend');

        setCookieDelFlag();

        if ( !empty($redirect) ) {
            $this->redirect($redirect);
        } else if ( !empty($nextstep) ) {
            $this->Post->set('step', $nextstep);
            $this->Post->set('action', 'update');
            $this->Post->set('column', acmsSerialize($this->extractColumn()));
            return $this->Post;
        } else if ( is_array($updatedResponse) ) {
            $Session =& Field::singleton('session');
            $Session->add('entry_action', 'update');

            $info   = array(
                'bid'   => BID,
                'cid'   => $updatedResponse['cid'],
                'eid'   => EID,
            );
            if ( $updatedResponse['trash'] == 'trash' ) {
                $info['query']  = array('trash' => 'show');
            }
            if ( !empty($backend) ) { 
                $info['admin']  = 'entry_editor';
            }

            $this->redirect(acmsLink($info));
        } else {
            return $this->Post;
        }
    }

    function isOperable()
    {
        if ( !EID ) return false;
        if ( !IS_LICENSED ) return false;

        if ( roleAvailableUser() ) {
            if ( !roleAuthorization('entry_edit', BID, EID) ) return false;
        } else {
            if ( !sessionWithCompilation(BID, false) ) {
                if ( !sessionWithContribution(BID, false) ) return false;
                if ( SUID <> ACMS_RAM::entryUser(EID) ) return false;
            }
        }
        return true;
    }
}
